module Alphabet where
import PreludeExt
import Input 
import Shifter 
import Array


alph:: Array Int (Int,Int) -> [[String]] -> Array Int (Int,Int)
alph circ_index line_storage = qalph 0 (numitems - 1) (alph_aux 0 alph_index0 circ_index)

  where

    numitems = snd (bounds circ_index) -- attention, le snd au lieu du pattern matching est pour se faciliter la vie avec l'automatisation du refactorer
                   
    alph_index0 = array (0,numitems) [(i,default_value) | i <- [0..numitems]]

    alph_aux i aindex cindex = 
	if i /= numitems
	then alph_aux (i+1) (aindex//[(i,(cindex!i))]) cindex
	else aindex
             

    csline_inf shift1 shift2 ls  = inf_aux 0
          where

            csword (lno,fwno) wordno ls =
	          nth (nth ls lno) (mod (fwno + wordno) (length (nth ls lno)))

            cswords shift ls =
	          length (nth ls (fst shift)) 
	
            lasti  = min (cswords shift1 ls) (cswords shift2 ls)
            
            inf_aux i = 
                let maxed_ = (i == lasti) 
                    cword1 = csword shift1 i ls
                    cword2 = csword shift2 i ls
                in 
	          if (maxed_ || (not (cword1 == cword2)))
	          then 
	              if maxed_ 
                      then lasti <= (cswords shift2 ls)
                      else cword1 <= cword2
	          else inf_aux (i+1)
   
           
    swap_indices::Array Int (Int,Int) -> Int -> Int -> Array Int (Int,Int)
    swap_indices vec i j = 
          let tempi = vec!i 
              tempj = vec!j
          in 
            vec // [(i,tempj),(j,tempi)] 


    qsplit start end split alph_index =
            let (l,aind) = qsplit_aux (start+1) end start (swap_indices alph_index start split) 
                aind2    = swap_indices aind split (l-1)
            in (aind2, l-1)

                where

                  qsplit_aux low high split alph_index  =
	              if not (low > high)
	              then 
	                  if csline_inf (alph_index!low) (alph_index!split) line_storage
	                  then qsplit_aux (low+1) high split alph_index
	                  else qsplit_aux low (high-1) split (swap_indices alph_index low high)
	              else (low, alph_index)


    qalph start end alph_index= 
            if start < end
            then
	        let 
                    split = start 
	            (aindex,middle) = qsplit start end split alph_index
	            aindex' = qalph start (middle-1) aindex 
                in
	          qalph (middle+1) end aindex'
            else alph_index
          